<?php

class ControllerExtensionShippingTotalBased extends Controller {

    private $error = array();

    public function index() {
        $this->language->load('extension/shipping/total_based');

        $this->document->setTitle($this->language->get('heading_title'));

        $this->load->model('setting/setting');

        if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validate()) {
            $this->model_setting_setting->editSetting('shipping_total_based', $this->request->post);

            $this->session->data['success'] = $this->language->get('text_success');

            // $this->response->redirect($this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'], 'SSL'));
            $this->response->redirect($this->url->link('extension/shipping/total_based', 'user_token=' . $this->session->data['user_token'], 'SSL'));

        }

        $data['heading_title'] = $this->language->get('heading_title');

        $data['text_none'] = $this->language->get('text_none');
        $data['text_enabled'] = $this->language->get('text_enabled');
        $data['text_disabled'] = $this->language->get('text_disabled');
        $data['text_edit'] = $this->language->get('text_edit');
        $data['text_shipping_rates_for'] = $this->language->get('text_shipping_rates_for');

        $data['entry_heading'] = $this->language->get('entry_heading');
        $data['entry_rate'] = $this->language->get('entry_rate');
        $data['entry_tax_class'] = $this->language->get('entry_tax_class');
        $data['entry_status'] = $this->language->get('entry_status');
        $data['entry_sort_order'] = $this->language->get('entry_sort_order');

        $data['button_save'] = $this->language->get('button_save');
        $data['button_cancel'] = $this->language->get('button_cancel');

        $data['tab_general'] = $this->language->get('tab_general');

        if (isset($this->error['warning'])) {
            $data['error_warning'] = $this->error['warning'];
        } else {
            $data['error_warning'] = '';
        }

        $data['breadcrumbs'] = array();

        $data['breadcrumbs'][] = array(
            'text' => $this->language->get('text_home'),
            'href' => $this->url->link('common/dashboard', 'user_token=' . $this->session->data['user_token'], 'SSL'),
            'separator' => false
        );

        $data['breadcrumbs'][] = array(
            'text' => $this->language->get('text_shipping'),
            'href' => $this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'], 'SSL'),
            'separator' => ' :: '
        );

        $data['breadcrumbs'][] = array(
            'text' => $this->language->get('heading_title'),
            'href' => $this->url->link('extension/shipping/total_based', 'user_token=' . $this->session->data['user_token'], 'SSL'),
            'separator' => ' :: '
        );

        $data['action'] = $this->url->link('extension/shipping/total_based', 'user_token=' . $this->session->data['user_token'], 'SSL');

        $data['cancel'] = $this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'], 'SSL');

        $this->load->model('localisation/geo_zone');

        $geo_zones = $this->model_localisation_geo_zone->getGeoZones();

        foreach ($geo_zones as $geo_zone) {
            if (isset($this->request->post['shipping_total_based_' . $geo_zone['geo_zone_id'] . '_rate'])) {
                $data['shipping_total_based_' . $geo_zone['geo_zone_id'] . '_rate'] = $this->request->post['shipping_total_based_' . $geo_zone['geo_zone_id'] . '_rate'];
            } elseif ($this->config->get('shipping_total_based_' . $geo_zone['geo_zone_id'] . '_rate')) {
                $data['shipping_total_based_' . $geo_zone['geo_zone_id'] . '_rate'] = $this->config->get('shipping_total_based_' . $geo_zone['geo_zone_id'] . '_rate');
            } else {
                $data['shipping_total_based_' . $geo_zone['geo_zone_id'] . '_rate'] = array("from" => array(""), "to" => array(""), "charge" => array(""));
            }

            if (isset($this->request->post['shipping_total_based_' . $geo_zone['geo_zone_id'] . '_status'])) {
                $data['shipping_total_based_' . $geo_zone['geo_zone_id'] . '_status'] = $this->request->post['shipping_total_based_' . $geo_zone['geo_zone_id'] . '_status'];
            } else {
                $data['shipping_total_based_' . $geo_zone['geo_zone_id'] . '_status'] = $this->config->get('shipping_total_based_' . $geo_zone['geo_zone_id'] . '_status');
            }
        }

        $data['geo_zones'] = $geo_zones;

        if (isset($this->request->post['shipping_total_based_tax_class_id'])) {
            $data['shipping_total_based_tax_class_id'] = $this->request->post['shipping_total_based_tax_class_id'];
        } else {
            $data['shipping_total_based_tax_class_id'] = $this->config->get('shipping_total_based_tax_class_id');
        }

        $this->load->model('localisation/tax_class');

        $data['tax_classes'] = $this->model_localisation_tax_class->getTaxClasses();

        if (isset($this->request->post['shipping_total_based_status'])) {
            $data['shipping_total_based_status'] = $this->request->post['shipping_total_based_status'];
        } else {
            $data['shipping_total_based_status'] = $this->config->get('shipping_total_based_status');
        }

        if (isset($this->request->post['shipping_total_based_sort_order'])) {
            $data['shipping_total_based_sort_order'] = $this->request->post['shipping_total_based_sort_order'];
        } else {
            $data['shipping_total_based_sort_order'] = $this->config->get('shipping_total_based_sort_order');
        }

        if (isset($this->request->post['shipping_total_based_heading'])) {
            $data['shipping_total_based_heading'] = $this->request->post['shipping_total_based_heading'];
        } else if ($this->config->get('shipping_total_based_heading') != "") {
            $data['shipping_total_based_heading'] = $this->config->get('shipping_total_based_heading');
        } else {
            $data['shipping_total_based_heading'] = "Total based shipping";
        }

        $data['header'] = $this->load->controller('common/header');
        $data['column_left'] = $this->load->controller('common/column_left');
        $data['footer'] = $this->load->controller('common/footer');

        $this->response->setOutput($this->load->view('extension/shipping/total_based', $data));
    }

    protected function validate() {
        if (!$this->user->hasPermission('modify', 'extension/shipping/total_based')) {
            $this->error['warning'] = $this->language->get('error_permission');
        }

        if (!$this->error) {
            return true;
        } else {
            return false;
        }
    }

}

?>
